Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.query
Class ImportedFunctionLibrary

    java.lang.Object
      net.sf.saxon.query.ImportedFunctionLibrary

All Implemented Interfaces:
  Serializable, FunctionLibrary, XQueryFunctionBinder

    public class ImportedFunctionLibrary

extends Object
implements FunctionLibrary, XQueryFunctionBinder

This implementation of FunctionLibrary contains all the functions imported into a Query Module. It is implemented as a view of the "global" XQueryFunctionLibrary for the whole query, selecting only those functions that are in an imported namespace.

See Also:
  Serialized Form

Constructor Summary
`ImportedFunctionLibrary(StaticQueryContext importingModule, XQueryFunctionLibrary baseLibrary)`

Method Summary
`void` | `addImportedNamespace(String namespace)`
`Expression` | `bind(int nameCode, String uri, String local, Expression[] staticArgs)` Bind an extension function, given the URI and local parts of the function name, and the list of expressions supplied as arguments.
`FunctionLibrary` | `copy()` This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
`XQueryFunction` | `getDeclaration(int nameCode, String uri, String local, Expression[] staticArgs)` Get the function declaration corresponding to a given function name and arity
`boolean` | `isAvailable(int fingerprint, String uri, String local, int arity)` Test whether an extension function with a given name and arity is available.
`void` | `setImportingModule(StaticQueryContext importingModule)`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ImportedFunctionLibrary

    public ImportedFunctionLibrary(StaticQueryContext importingModule,
                                   XQueryFunctionLibrary baseLibrary)

Method Detail

### addImportedNamespace

    public void addImportedNamespace(String namespace)

### bind

    public Expression bind(int nameCode,
                           String uri,
                           String local,
                           Expression[] staticArgs)
                    throws XPathException

  Bind an extension function, given the URI and local parts of the function name, and the list of expressions supplied as arguments. This method is called at compile time.

  Specified by:
    `bind` in interface `FunctionLibrary`
  Parameters:
    `nameCode` - The namepool nameCode of the function name. The uri and local name are also supplied (redundantly) to avoid fetching them from the name pool.
    `uri` - The URI of the function name
    `local` - The local part of the function name
    `staticArgs` - The expressions supplied statically in arguments to the function call. The length of this array represents the arity of the function. The intention is that the static type of the arguments (obtainable via getItemType() and getCardinality()) may be used as part of the binding algorithm. In some cases it may be possible for the function to be pre-evaluated at compile time, for example if these expressions are all constant values.

    The conventions of the XPath language demand that the results of a function depend only on the values of the expressions supplied as arguments, and not on the form of those expressions. For example, the result of f(4) is expected to be the same as f(2+2). The actual expression is supplied here to enable the binding mechanism to select the most efficient possible implementation (including compile-time pre-evaluation where appropriate).
  Returns:
    An object representing the function to be called, if one is found; null if no function was found matching the required name and arity.
  Throws:
    `XPathException` - if a function is found with the required name and arity, but the implementation of the function cannot be loaded or used; or if an error occurs while searching for the function.

### getDeclaration

    public XQueryFunction getDeclaration(int nameCode,
                                         String uri,
                                         String local,
                                         Expression[] staticArgs)

  Get the function declaration corresponding to a given function name and arity

  Specified by:
    `getDeclaration` in interface `XQueryFunctionBinder`
  Returns:
    the XQueryFunction if there is one, or null if not.

### copy

    public FunctionLibrary copy()

  This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.

  Specified by:
    `copy` in interface `FunctionLibrary`
  Returns:
    a copy of this function library. This must be an instance of the original class.

### setImportingModule

    public void setImportingModule(StaticQueryContext importingModule)

### isAvailable

    public boolean isAvailable(int fingerprint,
                               String uri,
                               String local,
                               int arity)

  Test whether an extension function with a given name and arity is available. This supports the function-available() function in XSLT. This method may be called either at compile time or at run time. If the function library is to be used only in an XQuery or free-standing XPath environment, this method may throw an UnsupportedOperationException.

  Specified by:
    `isAvailable` in interface `FunctionLibrary`
  Parameters:
    `fingerprint` - The namepool fingerprint of the function name. This must match the uri and localName; the information is provided redundantly to avoid repeated lookups in the name pool.
    `uri` - The URI of the function name
    `local` - The local part of the function name
    `arity` - The number of arguments. This is set to -1 in the case of the single-argument function-available() function; in this case the method should return true if there is some matching extension function, regardless of its arity.

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.